package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.GameEventBo;
import org.dromara.system.domain.vo.GameEventVo;
import org.dromara.system.domain.GameEvent;
import org.dromara.system.mapper.GameEventMapper;
import org.dromara.system.service.IGameEventService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 赛事基本信息Service业务层处理
 *
 * @author zlt
 * @date 2025-07-30
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class GameEventServiceImpl implements IGameEventService {

    private final GameEventMapper baseMapper;

    /**
     * 查询赛事基本信息
     *
     * @param eventId 主键
     * @return 赛事基本信息
     */
    @Override
    public GameEventVo queryById(Long eventId){
        return baseMapper.selectVoById(eventId);
    }

    /**
     * 分页查询赛事基本信息列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 赛事基本信息分页列表
     */
    @Override
    public TableDataInfo<GameEventVo> queryPageList(GameEventBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<GameEvent> lqw = buildQueryWrapper(bo);
        Page<GameEventVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的赛事基本信息列表
     *
     * @param bo 查询条件
     * @return 赛事基本信息列表
     */
    @Override
    public List<GameEventVo> queryList(GameEventBo bo) {
        LambdaQueryWrapper<GameEvent> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<GameEvent> buildQueryWrapper(GameEventBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<GameEvent> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(GameEvent::getEventId);
        lqw.eq(StringUtils.isNotBlank(bo.getEventCode()), GameEvent::getEventCode, bo.getEventCode());
        lqw.like(StringUtils.isNotBlank(bo.getEventName()), GameEvent::getEventName, bo.getEventName());
        lqw.eq(StringUtils.isNotBlank(bo.getEventType()), GameEvent::getEventType, bo.getEventType());
        lqw.eq(StringUtils.isNotBlank(bo.getLocation()), GameEvent::getLocation, bo.getLocation());
        lqw.eq(StringUtils.isNotBlank(bo.getPurpose()), GameEvent::getPurpose, bo.getPurpose());
        lqw.eq(StringUtils.isNotBlank(bo.getIsDefault()), GameEvent::getIsDefault, bo.getIsDefault());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), GameEvent::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增赛事基本信息
     *
     * @param bo 赛事基本信息
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(GameEventBo bo) {
        GameEvent add = MapstructUtils.convert(bo, GameEvent.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setEventId(add.getEventId());
        }
        return flag;
    }

    /**
     * 修改赛事基本信息
     *
     * @param bo 赛事基本信息
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(GameEventBo bo) {
        GameEvent update = MapstructUtils.convert(bo, GameEvent.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(GameEvent entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除赛事基本信息信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
